﻿Public Class Multiply
    Inherits FunctionBase

    Private fFactor1 As Double = 1
    Private fFactor2 As Double = 1

    Public Overrides Function Evaluate(ByVal x As Double, ByVal y As Double) As Double
        Return fFactor1 * fFactor2
    End Function

    Public Overrides ReadOnly Property Name As String
        Get
            Return "Multiply"
        End Get
    End Property

    Public Overrides ReadOnly Property Help As String
        Get
            Return "Gibt das Produkt von Factor 1 und Factor 2 aus."
        End Get
    End Property


    Public Overrides ReadOnly Property Type As FunctionType
        Get
            Return FunctionType.Function
        End Get
    End Property



    Public Overrides ReadOnly Property ParameterInfos As System.Data.DataTable
        Get
            Dim tbl As New DataTable
            tbl.Columns.Add("Index", GetType(Int32))
            tbl.Columns.Add("Name", GetType(String))
            tbl.Columns.Add("Step", GetType(Double))
            tbl.Columns.Add("Default", GetType(Double))
            tbl.Columns.Add("Current", GetType(Double))
            tbl.Rows.Add(0, "Factor 1", 0.1, 1, fFactor1)
            tbl.Rows.Add(1, "Factor 2", 0.1, 1, fFactor2)
            Return tbl

        End Get
    End Property



    Public Overrides Sub SetParameterValue(ByVal Index As Integer, ByVal Value As Double)
        Select Case Index
            Case 0
                fFactor1 = Value
            Case 1
                fFactor2 = Value
            Case Else
        End Select
    End Sub

    Public Overrides Sub AddParameterValue(Index As Integer, Value As Double)
        Select Case Index
            Case 0
                fFactor1 += Value
            Case 1
                fFactor2 += Value
        End Select
    End Sub
End Class
