﻿Public Interface IFunction
    ReadOnly Property Name As String
    ReadOnly Property Type As FunctionType
    Function Evaluate(ByVal x As Double, ByVal y As Double) As Double
    Sub SetParameterValue(ByVal Index As Int32, ByVal Value As Double)
    Sub SetParameterValue(ByVal Name As String, ByVal Value As Double)
    Sub AddParameterValue(ByVal Index As Int32, ByVal Value As Double)
    ReadOnly Property ParameterValue(ByVal Index As Int32) As Double
    ReadOnly Property ParameterInfos() As DataTable
    ReadOnly Property Help As String
    Sub Serialize(ByVal Parent As Xml.XmlNode)

    Property Guid() As Guid
    Property Outputs As List(Of OutputTo)
    Sub AddOutput(ByVal Output As OutputTo)
    Sub RemoveOutput(ByVal Output As OutputTo)
    Property RequiredInputCount As Int32
    Property ProvidedInputCount As Int32
    Property IsSolo As Boolean
    Property IsMute As Boolean
End Interface

Public Enum FunctionType
    Generator
    [Function]
    Player
    Repeater
    ImageOutput
End Enum